


#include <SPI.h>
long knock;
long knockpeak;

void setup() {
  SPI.begin();

  // initalize the  data ready and chip select pins:
  pinMode(51, OUTPUT);//to SDO on knock chip
  pinMode(50, INPUT);//to SDI on knock chip
  pinMode(4, OUTPUT);//Windowing trigger to int/hold on knock chip
  pinMode(49, OUTPUT);//CS to cable select pin on knock chip
  digitalWrite(49,HIGH);//place in standby
SPI.setBitOrder(MSBFIRST);
  //Configure SCP1000 for low noise configuration:
  SPI.setClockDivider(SPI_CLOCK_DIV8);
  SPI.setDataMode(SPI_MODE1);
   digitalWrite(49,LOW);
   Serial.println(SPI.transfer(B01110001));//set advanced mode returns 10001110 or 1492 
   digitalWrite(49,HIGH);
   delay(20);
   digitalWrite(49,LOW);
   Serial.println(SPI.transfer(B01000110)); //Oscilator frequency returns 649 - Returns D-7 to D0 of the digital integrator output.
   digitalWrite(49,HIGH);
   delay(20);
   digitalWrite(49,LOW);
   Serial.println(SPI.transfer(B11100000));//Set Channel to 1 Returns 2249 - Set the channel at 1 Returns D9 to D8 followed by six zeros
   digitalWrite(49,HIGH);
   delay(20);
   digitalWrite(49,LOW);
   Serial.println(SPI.transfer(B00010010));//Set the center band-pass freq 17 - 00000001
   digitalWrite(49,HIGH);
   delay(20);
   digitalWrite(49,LOW);
   Serial.println(SPI.transfer(B10111111));//set gain 11100000
   digitalWrite(49,HIGH);
   delay(20);
   digitalWrite(49,LOW);
   Serial.println(SPI.transfer(B11011111));//215
   digitalWrite(49,HIGH);
   delay(20);
  //******************* Clear the SPI data so that first knock indication is real.
   digitalWrite(49,LOW);
   knock = (SPI.transfer(B01000110)<<2); //Oscilator frequency returns 649 - Returns D-7 to D0 of the digital integrator output.
   digitalWrite(49,HIGH);
   delay(1);
   digitalWrite(49,LOW);
  knock= knock + (SPI.transfer(B11100000));//Set Channel to 1 Returns 2249 - Set the channel at 1 Returns D9 to D8 followed by six zeros
   digitalWrite(49,HIGH);
   Serial.println("*************");
  // give the sensor time to set up:
  delay(2000);
}

void loop(){
 
 //*********************READ SPI DATA******************************************
  digitalWrite(49,LOW);
   knock = (SPI.transfer(B01000110)<<2); //Oscilator frequency returns 649 - Returns D-7 to D0 of the digital integrator output.
   digitalWrite(49,HIGH);
   delay(1);
   digitalWrite(49,LOW);
  knock= knock + (SPI.transfer(B11100000));//Set Channel to 1 Returns 2249 - Set the channel at 1 Returns D9 to D8 followed by six zeros
   digitalWrite(49,HIGH);
   if (knock>knockpeak)
   {
     knockpeak=knock;
   }
   
   Serial.println(knock);//prints out the knock value.
   
   //*************************Start and stop window***************************************
   digitalWrite(4,HIGH);
   delay(60);
   digitalWrite(4,LOW);
   //*********************************END WINDOWING FUNCTION******************************
   
 
 
  
}
